##################################################################
'''
This is a custom Day and Night script.
Edit your configurations here.
'''
#This is how dark it will get at night
totalDarkness = 85
#This is the length of the day, in SECONDS
daySeconds = 120
#This is the length of the night, in SECONDS
nightSeconds = 120
#This is how long it takes the sun to rise. Higher values mean a longer time
sunriseTime = .2
#This is how long it takes the sun to set. Higher values mean a longer time
sunsetTime = .2
##################################################################

# DO NOT EDIT BELOW THIS LINE UNLESS YOU KNOW WHAT YOU ARE DOING

import es, gamethread

darkness = 0
night = 0
dayMinutes = int(daySeconds) / 60
nightMinutes = int(nightSeconds) / 60
dayMessageDelay = int(daySeconds) % 60
nightMessageDelay = int(nightSeconds) % 60

def load():
    messages()
    gamethread.delayed(daySeconds, makeDark)
    
def messages():
    if night == 0:
        es.msg('#lightgreen', 'It is now day!')
        gamethread.delayed(daySeconds, es.msg, ('#lightgreen', 'Prepare for night!'))
        x = dayMinutes
        while x > 0:
            delay = dayMinutes * 60 - x * 60
            gamethread.delayed(dayMessageDelay + delay, es.msg, ('#lightgreen', 'Nightfall will begin in %s minutes.'%x))
            x -= 1
    if night == 1:
        es.msg('#lightgreen', 'It is now night!')
        gamethread.delayed(nightSeconds, es.msg, ('#lightgreen', 'Prepare for day!'))
        x = nightMinutes
        while x > 0:
            delay = nightMinutes * 60 - x * 60
            gamethread.delayed(nightMessageDelay + delay, es.msg, ('#lightgreen', 'Sunrise will begin in %s minutes.'%x))
            x -= 1

def player_activate(ev):
    es.give(ev['userid'], 'env_fog_controller')
    dark(ev['userid'])

def makeDark():
    global darkness, night
    if darkness < totalDarkness:
        darkness += 1
        for userid in es.getUseridList():
            dark(userid)
        gamethread.delayed(sunsetTime, makeDark)
    else:
        night = 1
        messages()
        gamethread.delayed(nightSeconds, makeLight)

def makeLight():
    global darkness, night
    if darkness > 0:
        darkness -= 1
        for userid in es.getUseridList():
            dark(userid)
        gamethread.delayed(sunriseTime, makeLight)
    else:
        night = 0
        messages()
        gamethread.delayed(daySeconds, makeDark)

def dark(userid):
    es.server.queuecmd('es_fire %s env_fog_controller TurnOff'%userid)
    es.server.queuecmd('es_fire %s env_fog_controller addoutput "fogcolor 0 0 0,-1,0"'%userid)
    temp1 = '"fogstart %s,-1,0"'%(darkness * -100)
    temp2 = '"fogend %s,-1,0"'%(darkness * -100 + 10000)
    es.server.queuecmd('es_fire %s env_fog_controller addoutput %s'%(userid, temp1))   
    es.server.queuecmd('es_fire %s env_fog_controller addoutput %s'%(userid, temp2))
    es.server.queuecmd('es_fire %s env_fog_controller TurnOn'%userid)

def unload():
    es.msg('#lightgreen', 'It is now day!')
    for userid in es.getUseridList():
        es.server.queuecmd('es_fire %s env_fog_controller TurnOff'%userid)
        es.server.queuecmd('es_fire %s env_fog_controller addoutput "fogcolor 0 0 0,-1,0"'%userid)
        temp1 = '"fogstart %s,-1,0"'%(0 * -100)
        temp2 = '"fogend %s,-1,0"'%(0 * -100 + 10000)
        es.server.queuecmd('es_fire %s env_fog_controller addoutput %s'%(userid, temp1))   
        es.server.queuecmd('es_fire %s env_fog_controller addoutput %s'%(userid, temp2))
        es.server.queuecmd('es_fire %s env_fog_controller TurnOn'%userid)